function varargout = GPlan(varargin)
% GPLAN M-file for GPlan.fig
%      GPLAN, by itself, creates a new GPLAN or raises the existing
%      singleton*.
%
%      H = GPLAN returns the handle to a new GPLAN or the handle to
%      the existing singleton*.
%
%      GPLAN('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GPLAN.M with the given input arguments.
%
%      GPLAN('Property','Value',...) creates a new GPLAN or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before GPlan_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to GPlan_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help GPlan

% Last Modified by GUIDE v2.5 16-Mar-2006 17:34:42
% Written by A. McClung 04/13/05 - Stanford Univ.

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @GPlan_OpeningFcn, ...
                   'gui_OutputFcn',  @GPlan_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before GPlan is made visible.
function GPlan_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to GPlan (see VARARGIN)

% Choose default command line output for GPlan
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes GPlan wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = GPlan_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in Calc.
function Calc_Callback(hObject, eventdata, handles)
% hObject    handle to Calc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%Turn off the animation button
set(handles.AnimBut,'Value',0);
%Draw the new body and legs
%Reset the plot formatting
newplot(handles.BodyPlot);
cla(handles.BodyPlot);
set(handles.BodyPlot,'XColor','w')
set(handles.BodyPlot,'YColor','w')
set(handles.BodyPlot,'XTickLabel','')
set(handles.BodyPlot,'YTickLabel','')
bodyWidth=0.4;
bodyLength=0.6;
legRadius=0.08;
legSpace=1.7;
numLegs=4;
%Get the GUI editable values
legphase(1)=str2num(get(handles.Leg0PhaseOffset,'String'));
legphase(2)=str2num(get(handles.Leg1PhaseOffset,'String'));
legphase(3)=str2num(get(handles.Leg2PhaseOffset,'String'));
legphase(4)=str2num(get(handles.Leg3PhaseOffset,'String'));
legwing(1)=str2num(get(handles.Leg0WingOffset,'String'));
legwing(2)=str2num(get(handles.Leg1WingOffset,'String'));
legwing(3)=str2num(get(handles.Leg2WingOffset,'String'));
legwing(4)=str2num(get(handles.Leg3WingOffset,'String'));
DC=str2num(get(handles.DC,'String'));
AttDC=str2num(get(handles.AttDC,'String'));
DetDC=str2num(get(handles.DetDC,'String'));

%Plot the body
hold(handles.BodyPlot,'on');
plot(handles.BodyPlot,[-bodyWidth/2 bodyWidth/2 bodyWidth/2 -bodyWidth/2 -bodyWidth/2 ],...
    [-bodyLength/2 -bodyLength/2 bodyLength/2 bodyLength/2 -bodyLength/2],'k')
%Plot the legs (legs must be in pairs, ie. even #)
for i=1:numLegs/2
    xpos=bodyWidth*legSpace/2;
    ypos=bodyLength/2-bodyLength*((i-1)/(numLegs/2-1));
    circle5(xpos,ypos,legRadius,'br',handles.BodyPlot);
    circle5(-xpos,ypos,legRadius,'br',handles.BodyPlot);
    h=text(xpos*1.5,ypos,[num2str(numLegs-i)]);
    set(h,'Parent',handles.BodyPlot);  %Hack to get labels in right window
    h=text(-xpos*1.6,ypos,[num2str(i-1)]);
    set(h,'Parent',handles.BodyPlot);
end
set(handles.BodyPlot,'XLim',[-1,1])
set(handles.BodyPlot,'YLim',[-1,1])
%Draw the new leg temporal maps
newplot(handles.LegTimePlot);
cla(handles.LegTimePlot);
set(handles.LegTimePlot,'XGrid','on');
set(handles.LegTimePlot,'YTickLabel','')
hold(handles.LegTimePlot,'on');
tempSpace=1/(numLegs+1);
legOffset=str2num(get(handles.Leg3PhaseOffset,'String'));
c='rgbcmywk';
ylabelpos=0;
ylabeltext='';
%Plot the top and bottom limits on temporal display and fill in w/colors
for i=1:numLegs
    bot=i*tempSpace/(numLegs+1)+(i-1)*tempSpace;
    top=i*tempSpace/(numLegs+1)+i*tempSpace;
    plot(handles.LegTimePlot,[0 1],[bot bot],'k');
    plot(handles.LegTimePlot,[0 1],[top top],'k');
    templeg=fill([0 1 1 0],[bot bot top top],[.67 .67 .67]);
    set(templeg,'FaceAlpha',.2);
    %Calculate the leg timing and phasing
    here=legphase(i);
    there=here+DC;
    h=fill([here there there here],[bot bot top top],c(3));
    set(h,'FaceAlpha',.5);
    if there>1
        there=mod(there,1);
        h=fill([0 there there 0],[bot bot top top],c(3));
        set(h,'FaceAlpha',.5);
    end
    %Add graphics for attachment
    hereADC=here-AttDC;
    thereADC=here;
    h=fill([hereADC thereADC thereADC hereADC],[bot bot top top],c(2));
    set(h,'FaceAlpha',.5);
    if hereADC<0
        hereADC=mod(hereADC,1);
        h=fill([1 hereADC hereADC 1],[bot bot top top],c(2));
        set(h,'FaceAlpha',.5);
    end
    if thereADC>1
        thereADC=mod(thereADC,1);
        h=fill([0 thereADC thereADC 0],[bot bot top top],c(2));
        set(h,'FaceAlpha',.5);
    end
    %Add graphics for detachment
    hereDDC=there;
    thereDDC=hereDDC+DetDC;
    h=fill([hereDDC thereDDC thereDDC hereDDC],[bot bot top top],c(1));
    set(h,'FaceAlpha',.5);
    if hereDDC<0
        hereDDC=mod(hereDDC,1);
        h=fill([1 hereDDC hereDDC 1],[bot bot top top],c(2));
        set(h,'FaceAlpha',.5);
    end
    if thereDDC>1
        thereDDC=mod(thereDDC,1);
        h=fill([0 thereDDC thereDDC 0],[bot bot top top],c(1));
        set(h,'FaceAlpha',.5);
    end

    ylabelpos(i)=bot+tempSpace/2;
    ylabeltext=[ylabeltext; 'Leg #' num2str(i-1)];
end
set(handles.LegTimePlot,'XLim',[0,1])
set(handles.LegTimePlot,'YLim',[0,1])
set(handles.LegTimePlot,'YTick',ylabelpos)
set(handles.LegTimePlot,'YTickLabel',ylabeltext)


% --- Executes on button press in AnimBut.
function AnimBut_Callback(hObject, eventdata, handles)
% hObject    handle to AnimBut (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of AnimBut
speedConstant=25;
curtime=0;
timeBar=plot(handles.LegTimePlot,[0 0],[0 1],'k');
set(timeBar,'LineWidth',2);
speed=get(handles.PeriodSlider,'Value');
%Same basic constants as above
bodyWidth=0.4;
bodyLength=0.6;
legRadius=0.08;
legSpace=1.7;
numLegs=4;
tempSpace=1/(numLegs+1);
DC=str2num(get(handles.DC,'String'));
%Get the GUI editable values
legphase(1)=str2num(get(handles.Leg0PhaseOffset,'String'));
legphase(2)=str2num(get(handles.Leg1PhaseOffset,'String'));
legphase(3)=str2num(get(handles.Leg2PhaseOffset,'String'));
legphase(4)=str2num(get(handles.Leg3PhaseOffset,'String'));
DC=str2num(get(handles.DC,'String'));
AttDC=str2num(get(handles.AttDC,'String'));
DetDC=str2num(get(handles.DetDC,'String'));
c='rgbcmywk';
%Draw the legs for animation
for i=1:numLegs/2
    xpos=bodyWidth*legSpace/2;
    ypos=bodyLength/2-bodyLength*((i-1)/(numLegs/2-1));
    Leg(numLegs+1-i)=circle5(xpos,ypos,legRadius,'br',handles.BodyPlot);
    Leg(i)=circle5(-xpos,ypos,legRadius,'br',handles.BodyPlot);
end
%Build up a temporal table for legs
%HERE is the where things start, and THERE is where things stop
for i=1:numLegs
    %Stance
    here(i)=legphase(i);
    there(i)=here(i)+DC;
    if there(i)>1
        there(i)=mod(there(i),1);
    end
    %Attachment
    hereADC(i)=here(i)-AttDC;
    thereADC(i)=here(i);
    if hereADC(i)<0
        hereADC(i)=mod(hereADC(i),1);
    end
    if thereADC(i)>1
        thereADC(i)=mod(thereADC(i),1);
    end
    %Add graphics for detachment
    hereDDC(i)=there(i);
    thereDDC(i)=hereDDC(i)+DetDC;
    if hereDDC(i)<0
        hereDDC(i)=mod(hereDDC(i),1);
    end
    if thereDDC(i)>1
        thereDDC(i)=mod(thereDDC(i),1);
    end
end
%Animate the plots
while get(hObject,'Value')==1
    speed=get(handles.PeriodSlider,'Value');
    curtime=mod(curtime+speed/speedConstant,1);
    set(timeBar,'XData',[curtime curtime]);
    for i=1:numLegs
        LegActive(i)=0;
        %Stance (following comments are relative to temporal plot sections)
        if (((curtime<there(i))&(there(i)<here(i))) | ... %For the front end
                ((curtime>here(i))&(curtime<there(i))) | ... %For the middle
                ((here(i)>there(i))&(curtime>here(i)))) %For the tail end
            set(Leg(i),'Color',c(3),'LineWidth',3);
            LegActive(i)=1;
        end
        %Attachment (following comments are relative to temporal plot sections)
        if (((curtime<thereADC(i))&(thereADC(i)<hereADC(i))) | ... %For the front end
                ((curtime>hereADC(i))&(curtime<thereADC(i))) | ... %For the middle
                ((hereADC(i)>thereADC(i))&(curtime>hereADC(i)))) %For the tail end
            set(Leg(i),'Color',c(2),'LineWidth',3);
            LegActive(i)=2;
        end
        %Detachment (following comments are relative to temporal plot sections)
        if (((curtime<thereDDC(i))&(thereDDC(i)<hereDDC(i))) | ... %For the front end
                ((curtime>hereDDC(i))&(curtime<thereDDC(i))) | ... %For the middle
                ((hereDDC(i)>thereDDC(i))&(curtime>hereDDC(i)))) %For the tail end
            set(Leg(i),'Color',c(1),'LineWidth',3);
            LegActive(i)=3;
        end
        %Swing phase
        if LegActive(i)==0
            set(Leg(i),'Color','k','LineWidth',0.1);
        end
    end
    pause(0.1);
end
%Clean up animation stuff
if ishandle(timeBar)  %If these have not been cleared, clear them
    delete(timeBar);
    for i=1:numLegs
        delete(Leg(i));
    end
end



%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%



% --- Executes on slider movement.
function PeriodSlider_Callback(hObject, eventdata, handles)
% hObject    handle to PeriodSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

periodBounds=[2 20];  %Bounds for the slider (in secs)
periodslide=1-get(handles.PeriodSlider,'Value');
%set(handles.Period,'String',num2str(periodBounds(1)+periodslide*diff(periodBounds)),'%1.2f');
set(handles.Period,'String',num2str(periodBounds(1)+periodslide*diff(periodBounds),'%1.2f'));
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function PeriodSlider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to PeriodSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function Period_Callback(hObject, eventdata, handles)
% hObject    handle to Period (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Period as text
%        str2double(get(hObject,'String')) returns contents of Period as a double

periodBounds=[2 20];  %Bounds for the slider (in secs)
period=str2num(get(handles.Period,'String'));
if period<periodBounds(1)
    period=periodBounds(1);
end
if period>periodBounds(2)
    period=periodBounds(2);
end
set(handles.PeriodSlider,'Value',1-((period-periodBounds(1))/diff(periodBounds)));
set(handles.Period,'String',num2str(period,'%1.2f'));
% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function Period_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Period (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function DC_Callback(hObject, eventdata, handles)
% hObject    handle to DC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of DC as text
%        str2double(get(hObject,'String')) returns contents of DC as a double

DC=str2num(get(handles.DC,'String'));
if DC>=1
    DC=0;
    set(handles.DC,'String','0.00');
end
% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function DC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to DC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function DetDC_Callback(hObject, eventdata, handles)
% hObject    handle to DetDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of DetDC as text
%        str2double(get(hObject,'String')) returns contents of DetDC as a double

DetDC=str2num(get(handles.DetDC,'String'));
if DetDC>=1
    DetDC=0;
    set(handles.DetDC,'String','0.00');
end
% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function DetDC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to DetDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function AttDC_Callback(hObject, eventdata, handles)
% hObject    handle to AttDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of AttDC as text
%        str2double(get(hObject,'String')) returns contents of AttDC as a double

AttDC=str2num(get(handles.AttDC,'String'));
if AttDC>=1
    AttDC=0;
    set(handles.AttDC,'String','0.00');
end
% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function AttDC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to AttDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%




function Leg0PhaseOffset_Callback(hObject, eventdata, handles)
% hObject    handle to Leg0PhaseOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Leg0PhaseOffset as text
%        str2double(get(hObject,'String')) returns contents of Leg0PhaseOffset as a double

legphase(1)=str2num(get(handles.Leg0PhaseOffset,'String'));
if legphase(1)>=1
    legphase(1)=0;
    set(handles.Leg0PhaseOffset,'String','0.00');
end
% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function Leg0PhaseOffset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Leg0PhaseOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function Leg1PhaseOffset_Callback(hObject, eventdata, handles)
% hObject    handle to Leg1PhaseOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Leg1PhaseOffset as text
%        str2double(get(hObject,'String')) returns contents of Leg1PhaseOffset as a double

legphase(2)=str2num(get(handles.Leg1PhaseOffset,'String'));
if legphase(2)>=1
    legphase(2)=0;
    set(handles.Leg1PhaseOffset,'String','0.00');
end
% Update handles structure
guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function Leg1PhaseOffset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Leg1PhaseOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function Leg2PhaseOffset_Callback(hObject, eventdata, handles)
% hObject    handle to Leg2PhaseOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Leg2PhaseOffset as text
%        str2double(get(hObject,'String')) returns contents of Leg2PhaseOffset as a double

legphase(3)=str2num(get(handles.Leg2PhaseOffset,'String'));
if legphase(3)>=1
    legphase(3)=0;
    set(handles.Leg2PhaseOffset,'String','0.00');
end
% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function Leg2PhaseOffset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Leg2PhaseOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function Leg3PhaseOffset_Callback(hObject, eventdata, handles)
% hObject    handle to Leg3PhaseOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Leg3PhaseOffset as text
%        str2double(get(hObject,'String')) returns contents of Leg3PhaseOffset as a double

legphase(4)=str2num(get(handles.Leg3PhaseOffset,'String'));
if legphase(4)>=1
    legphase(4)=0;
    set(handles.Leg3PhaseOffset,'String','0.00');
end
% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function Leg3PhaseOffset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Leg3PhaseOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%





function Leg0WingOffset_Callback(hObject, eventdata, handles)
% hObject    handle to Leg0WingOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Leg0WingOffset as text
%        str2double(get(hObject,'String')) returns contents of Leg0WingOffset as a double


% --- Executes during object creation, after setting all properties.
function Leg0WingOffset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Leg0WingOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function Leg1WingOffset_Callback(hObject, eventdata, handles)
% hObject    handle to Leg1WingOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Leg1WingOffset as text
%        str2double(get(hObject,'String')) returns contents of Leg1WingOffset as a double


% --- Executes during object creation, after setting all properties.
function Leg1WingOffset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Leg1WingOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function Leg2WingOffset_Callback(hObject, eventdata, handles)
% hObject    handle to Leg2WingOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Leg2WingOffset as text
%        str2double(get(hObject,'String')) returns contents of Leg2WingOffset as a double


% --- Executes during object creation, after setting all properties.
function Leg2WingOffset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Leg2WingOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function Leg3WingOffset_Callback(hObject, eventdata, handles)
% hObject    handle to Leg3WingOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Leg3WingOffset as text
%        str2double(get(hObject,'String')) returns contents of Leg3WingOffset as a double


% --- Executes during object creation, after setting all properties.
function Leg3WingOffset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Leg3WingOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function strokelength_Callback(hObject, eventdata, handles)
% hObject    handle to strokelength (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of strokelength as text
%        str2double(get(hObject,'String')) returns contents of strokelength as a double


% --- Executes during object creation, after setting all properties.
function strokelength_CreateFcn(hObject, eventdata, handles)
% hObject    handle to strokelength (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function footactuationlength_Callback(hObject, eventdata, handles)
% hObject    handle to footactuationlength (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of footactuationlength as text
%        str2double(get(hObject,'String')) returns contents of footactuationlength as a double


% --- Executes during object creation, after setting all properties.
function footactuationlength_CreateFcn(hObject, eventdata, handles)
% hObject    handle to footactuationlength (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Leg3StrokeOffset_Callback(hObject, eventdata, handles)
% hObject    handle to Leg3StrokeOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Leg3StrokeOffset as text
%        str2double(get(hObject,'String')) returns contents of Leg3StrokeOffset as a double


% --- Executes during object creation, after setting all properties.
function Leg3StrokeOffset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Leg3StrokeOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function Leg2StrokeOffset_Callback(hObject, eventdata, handles)
% hObject    handle to Leg2StrokeOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Leg2StrokeOffset as text
%        str2double(get(hObject,'String')) returns contents of Leg2StrokeOffset as a double


% --- Executes during object creation, after setting all properties.
function Leg2StrokeOffset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Leg2StrokeOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function Leg1StrokeOffset_Callback(hObject, eventdata, handles)
% hObject    handle to Leg1StrokeOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Leg1StrokeOffset as text
%        str2double(get(hObject,'String')) returns contents of Leg1StrokeOffset as a double


% --- Executes during object creation, after setting all properties.
function Leg1StrokeOffset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Leg1StrokeOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function Leg0StrokeOffset_Callback(hObject, eventdata, handles)
% hObject    handle to Leg0StrokeOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Leg0StrokeOffset as text
%        str2double(get(hObject,'String')) returns contents of Leg0StrokeOffset as a double


% --- Executes during object creation, after setting all properties.
function Leg0StrokeOffset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Leg0StrokeOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function Leg3FootOffset_Callback(hObject, eventdata, handles)
% hObject    handle to Leg3FootOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Leg3FootOffset as text
%        str2double(get(hObject,'String')) returns contents of Leg3FootOffset as a double


% --- Executes during object creation, after setting all properties.
function Leg3FootOffset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Leg3FootOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function Leg2FootOffset_Callback(hObject, eventdata, handles)
% hObject    handle to Leg2FootOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Leg2FootOffset as text
%        str2double(get(hObject,'String')) returns contents of Leg2FootOffset as a double


% --- Executes during object creation, after setting all properties.
function Leg2FootOffset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Leg2FootOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function Leg1FootOffset_Callback(hObject, eventdata, handles)
% hObject    handle to Leg1FootOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Leg1FootOffset as text
%        str2double(get(hObject,'String')) returns contents of Leg1FootOffset as a double


% --- Executes during object creation, after setting all properties.
function Leg1FootOffset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Leg1FootOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Leg0FootOffset_Callback(hObject, eventdata, handles)
% hObject    handle to Leg0FootOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Leg0FootOffset as text
%        str2double(get(hObject,'String')) returns contents of Leg0FootOffset as a double


% --- Executes during object creation, after setting all properties.
function Leg0FootOffset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Leg0FootOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function WingMag_Callback(hObject, eventdata, handles)
% hObject    handle to WingMag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of WingMag as text
%        str2double(get(hObject,'String')) returns contents of WingMag as a double


% --- Executes during object creation, after setting all properties.
function WingMag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to WingMag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%



% --- Executes on button press in WriteDAT2.
function WriteDAT2_Callback(hObject, eventdata, handles)
% hObject    handle to WriteDAT2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

servtab=CreateGaitTable(handles);   %Get the table of servo positions
N=size(servtab,1);                  %Number of sequence steps
W=size(servtab,2);                  %Number of columns

%Write the file
[nfile, pfile]=uiputfile('*.dat','Save As');
if length(nfile)<=3
    nfile=[nfile '.dat'];
else if strcmp(nfile(length(nfile)-3:length(nfile)),'.dat')~=1
        nfile=[nfile '.dat'];
    end
end
eval(['fid=fopen(''' nfile ''',''w'');'])
%Add the data for all the servos
for i=1:N
    %Write each column of data
    for j=1:W-1
        fprintf(fid,'%d\t',servtab(i,j));
    end
    %Add the step duration info
    fprintf(fid,'%d\t\r',servtab(i,W));
end
fclose(fid);


% --- Executes on button press in WriteDAT3.
function WriteDAT3_Callback(hObject, eventdata, handles)
% hObject    handle to WriteDAT3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

servtab=CreateGaitTable(handles);   %Get the table of servo positions
N=size(servtab,1);                  %Number of sequence steps
W=size(servtab,2);                  %Number of columns

%Write the file
[nfile, pfile]=uiputfile('*.dat','Save As');
if length(nfile)<=3
    nfile=[nfile '.dat'];
else if strcmp(nfile(length(nfile)-3:length(nfile)),'.dat')~=1
        nfile=[nfile '.dat'];
    end
end
eval(['fid=fopen(''' nfile ''',''w'');'])

%Enter the proper formatting for ver3 servo controller software to read
fprintf(fid,'Index\r');
fprintf(fid,' %d\r',N);
for i=1:15
    fprintf(fid,' 0\r');
end
fprintf(fid,'Sequence 0\r');

%Add the data for all the servos
for i=1:N
    for j=1:W-1
        fprintf(fid,'%d\t',servtab(i,j));
    end
    %Add the step duration info
    fprintf(fid,'%d\t\r',servtab(i,W));
end

%Enter the proper formatting for ver3 servo controller software to read
for i=1:15
    fprintf(fid,'Sequence %d\r',i);
end
fclose(fid);

%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%



% CREATEGAITTABLE will create a table of the servo positions that 
%  correspond to the user defined gait
function dataout=CreateGaitTable(handles)

%Get the GUI editable values
legphase(1)=str2num(get(handles.Leg0PhaseOffset,'String'));
legphase(2)=str2num(get(handles.Leg1PhaseOffset,'String'));
legphase(3)=str2num(get(handles.Leg2PhaseOffset,'String'));
legphase(4)=str2num(get(handles.Leg3PhaseOffset,'String'));
DC=str2num(get(handles.DC,'String'));
AttDC=str2num(get(handles.AttDC,'String'));
DetDC=str2num(get(handles.DetDC,'String'));
period=str2num(get(handles.Period,'String'));
strokelength=str2num(get(handles.strokelength,'String'));
footactuationlength=str2num(get(handles.footactuationlength,'String'));
legwingmag=str2num(get(handles.WingMag,'String'));
legwingoffset(1)=str2num(get(handles.Leg0WingOffset,'String'));
legwingoffset(2)=str2num(get(handles.Leg1WingOffset,'String'));
legwingoffset(3)=str2num(get(handles.Leg2WingOffset,'String'));
legwingoffset(4)=str2num(get(handles.Leg3WingOffset,'String'));
legstrokeoffset(1)=str2num(get(handles.Leg0StrokeOffset,'String'));
legstrokeoffset(2)=str2num(get(handles.Leg1StrokeOffset,'String'));
legstrokeoffset(3)=str2num(get(handles.Leg2StrokeOffset,'String'));
legstrokeoffset(4)=str2num(get(handles.Leg3StrokeOffset,'String'));
legfootoffset(1)=str2num(get(handles.Leg0FootOffset,'String'));
legfootoffset(2)=str2num(get(handles.Leg1FootOffset,'String'));
legfootoffset(3)=str2num(get(handles.Leg2FootOffset,'String'));
legfootoffset(4)=str2num(get(handles.Leg3FootOffset,'String'));


%Calculate some useful variables
numLegs=4;
f=50;           %NOTE: Had to change? to 50Hz to work w/VM servo controller
N=f*period;     % Number of steps in the sequence (limited to 256 for ver3)
stepdur=1/f*1000;
if N>256        %NOTE: The sequences can only be up to 256 frames
    stepdur=(period/256);
    N=256;
end

%Calculate the servo sequence (in DC space)
for i=1:numLegs
    %Stance
    start(i)=legphase(i);
    stop(i)=start(i)+DC;
    if stop(i)>1
        stop(i)=mod(stop(i),1);
    end
    %Attachment
    startADC(i)=start(i)-AttDC;
    stopADC(i)=start(i);
    if startADC(i)<0
        startADC(i)=mod(startADC(i),1);
    end
    if stopADC(i)>1
        stopADC(i)=mod(stopADC(i),1);
    end
    %Detachment
    startDDC(i)=stop(i);
    stopDDC(i)=startDDC(i)+DetDC;
    if startDDC(i)<0
        startDDC(i)=mod(startDDC(i),1);
    end
    if stopDDC(i)>1
        stopDDC(i)=mod(stopDDC(i),1);
    end
end

%Add the servo values
%Create a table for the servo values
for i=1:N
    if (i==248) 
    end
    rowcount=0;
    curtime=i/N;        %Timing on [0,1] scale, similar to temporal view
    %% NOTE: Currently this assumes servos are numbered sequentially for
    %% each leg (ie. S0=leg 0 wing, S1=leg 0 stroke, S2=leg 0 foot actuation)
    %% TRACKER variable was used for debugging
    %% SERVTAB holds the sequence for the servos
    %% The base value (128) may need to be updated for wing, stroke and foot
    for j=1:numLegs
        LegStance=0;
        %
        % WING ANGLE
        %
        %Stance (following comments are relative to temporal plot sections)
        if (((curtime<stop(j))&(stop(j)<start(j))) | ... %For the front end
                ((curtime>=start(j))&(curtime<stop(j))) | ... %For the middle
                ((start(j)>stop(j))&(curtime>=start(j)))) %For the tail end
            LegStance=1;
            rowcount=rowcount+1;
            tracker(i,rowcount)=1;
            servtab(i,rowcount)=legwingoffset(j)+legwingmag;     %Simply add the wing offset
        end
        %Attachment (following comments are relative to temporal plot sections)
        if ((((curtime<=stopADC(j))&(stopADC(j)<startADC(j))) | ... %For the front end
                ((curtime>=startADC(j))&(curtime<stopADC(j))) | ... %For the middle
                ((startADC(j)>stopADC(j))&(curtime>=startADC(j)))) & ... %For the tail end
                (LegStance==0))
            %NOTE: This should gradually ramp down the wing
            LegStance=2;
            rowcount=rowcount+1;
            tracker(i,rowcount)=2;
            %Add the wing offset, and linearly interpolate motion in the
            %attachment zone (add a percentage of the wing offset value, based on the current time)
            if (curtime<startADC(j))
                %ZONE: Front end attachment wraparound fix
                servtab(i,rowcount)=legwingoffset(j)+legwingmag+ ...
                    floor(legwingmag*(curtime-mod(startADC(j)+AttDC,1))/AttDC);
            else
                %ZONE: Attachment not wrapping around zero
                servtab(i,rowcount)=legwingoffset(j)+legwingmag+ ...
                    floor(legwingmag*(curtime-startADC(j)-AttDC)/AttDC);
            end
        end
        %Detachment (following comments are relative to temporal plot sections)
        if ((((curtime<stopDDC(j))&(stopDDC(j)<startDDC(j))) | ... %For the front end
                ((curtime>=startDDC(j))&(curtime<stopDDC(j))) | ... %For the middle
                ((startDDC(j)>stopDDC(j))&(curtime>=startDDC(j)))) & ... %For the tail end
                (LegStance==0))
            %NOTE: This should gradually ramp up the wing
            LegStance=3;
            rowcount=rowcount+1;
            tracker(i,rowcount)=3;
            %Add the wing offset, and linearly interpolate motion in the
            %detachment zone (add a percentage of the wing offset value, based on the current time)
            if (curtime<stopDDC(j))&&(curtime<startDDC(j))
                %ZONE: Rear end detachment wraparound fix
                servtab(i,rowcount)=legwingoffset(j)+ ...
                    floor(legwingmag*(mod(startDDC(j)+DetDC,1)-curtime)/DetDC);
            else
                %ZONE: Detachment not wrapping around zero
                servtab(i,rowcount)=legwingoffset(j)+ ...
                    floor(legwingmag*(startDDC(j)+DetDC-curtime)/DetDC);
            end
        end
        if LegStance==0
            rowcount=rowcount+1;
            tracker(i,rowcount)=0;
            %Leave the leg at the base value if its not in stance, attachment or detachment
            servtab(i,rowcount)=legwingoffset(j);
        end

        %
        % STROKE
        %
        %NOTE: This should drag the leg thru the stroke length
        % Half below and half above middle range (128)
        % Recirculate outside of attach and detach phases
        %fprintf(fid,'%d\t',128+floor(strokelength*(start(j)+DC-curtime-legphase(j))/DC)-strokelength/2);
        if ((LegStance==0)||(LegStance==2)||(LegStance==3))
            rowcount=rowcount+1;
            switch(LegStance)
                case 0
                    if curtime<=mod(start(j)-AttDC,1)
                        %ZONE: Swing in front/middle of temporal region
                        tracker(i,rowcount)=1;
                        %Add the stroke length, and linearly interpolate motion thru the swing 
                        % (add a percentage of the stroke length value, based on the current time)
                        servtab(i,rowcount)=legstrokeoffset(j)+strokelength- ...
                            floor(strokelength*(mod(start(j)-AttDC,1)-curtime)/(1-DC-AttDC-DetDC))-strokelength/2;
                    else
                        %ZONE: Swing at end of temporal region
                        %Add the stroke length, and linearly interpolate motion thru the swing 
                        % (add a percentage of the stroke length value, based on the current time)
                        tracker(i,rowcount)=2;
                        servtab(i,rowcount)=legstrokeoffset(j)+ ...
                            floor(strokelength*(curtime-stop(j)-DetDC)/(1-DC-AttDC-DetDC))-strokelength/2;
                    end
                case 2
                    %ZONE: Attachment
                    %Use the previous value
                    tracker(i,rowcount)=5;
                    %Account for i=1, calculate pos at end of swing for attachment
                    if i==1
                        servtab(i,rowcount)=legstrokeoffset(j)+strokelength/2;
                    else
                        servtab(i,rowcount)=servtab(i-1,rowcount);
                    end
                case 3
                    %ZONE: Detachment 
                    %Use the previous value
                    tracker(i,rowcount)=5;
                    %Account for i=1, calculate pos at end of stroke for detachment
                    if i==1
                        servtab(i,rowcount)=legstrokeoffset(j)-strokelength/2;
                    else
                        servtab(i,rowcount)=servtab(i-1,rowcount);
                    end
            end
        else
            rowcount=rowcount+1;
            if curtime>stop(j)
                %ZONE: Stance at the end of the temporal region
                tracker(i,rowcount)=3;
                %Add the stroke length, and linearly interpolate motion thru the stroke
                % (add a percentage of the stroke length value, based on the current time)
                servtab(i,rowcount)=legstrokeoffset(j)+ ...
                    floor(strokelength*(start(j)+DC-curtime)/DC)-strokelength/2;
            else
                %ZONE: Stance at the front/middle of the temporal region
                tracker(i,rowcount)=4;
                %Add the stroke length, and linearly interpolate motion thru the stroke
                % (add a percentage of the stroke length value, based on the current time)
                servtab(i,rowcount)=legstrokeoffset(j)+ ...
                    floor(strokelength*(stop(j)-curtime)/DC)-strokelength/2;
            end
        end
        %
        % FOOT ACTUATION
        %
        %NOTE: Currently this is just binary
        rowcount=rowcount+1;
        if (((curtime<stop(j))&(stop(j)<start(j))) | ... %For the front end
                ((curtime>start(j))&(curtime<stop(j))) | ... %For the middle
                ((start(j)>stop(j))&(curtime>start(j)))) %For the tail end
            %ZONE: Actuated
            tracker(i,rowcount)=1;
            servtab(i,rowcount)=legfootoffset(j)+footactuationlength;
        else
            %ZONE: Unactuated
            tracker(i,rowcount)=2;
            servtab(i,rowcount)=legfootoffset(j);
        end

    end

    %Had to change to \r rather than \n to work with Servo Controller program (TM -01/14/05)
    rowcount=rowcount+1;
    tracker(i,rowcount)=0;
    servtab(i,rowcount)=stepdur;
end
dataout=ServoTrans(servtab);
%dataout=servtab;  %For Debugging



% SERVOTRANS will transform a servo sequence table to a form that matches
% the current wiring of Spinybot.  This is basically a column swapper.
% NOTE: The legs are numbered counterclockwise (starting with 0) from the
% top left.  This is similar to the RiSE leg numbering.
% Example:    
%                    ************   
%            Leg 0   *          *   Leg 3
%                    *          *
%                    *          *
%                    *          *
%                    *          *
%                    *          *
%            Leg 1   *          *   Leg 2
%                    ************

function dataout=ServoTrans(datain)

%Legs are determined by columns of the following variables, ie. [0 1 2 3]
%  and the numbers are the servos numbered by the servo controller
%  software/hardware/firmware (#0-11)
%(Based on 03/15/06 StickyBot setup -TM)
WingServ=[9 6 3 0]+1;          %Add 1 to work w/Matlab matrices
StrokeServ=[11 8 5 2]+1;       %Add 1 to work w/Matlab matrices
FootServ=[1 4 7 10]+1;         %Add 1 to work w/Matlab matrices
numLegs=4;

%Reverse the stroke for the left legs (flip it about the mid value, ie. 128)
%NOTE: Same servo signals move left and right legs in different dirrections
datain(:,5)=2*128-datain(:,5);     %Stroke for left rear leg
datain(:,2)=2*128-datain(:,2);     %Stroke for left front leg
%Reverse the wing for leg #0 and #2 (flip it about the mid value, ie. 128)
datain(:,[1])=2*128-datain(:,[1]);  %Stroke for left front leg
datain(:,[7])=2*128-datain(:,[7]);  %Stroke for right rear leg
%Reverse the foot actuation for leg #0 and #2 (flip it about the mid value, ie. 128)
datain(:,[3])=2*128-datain(:,[3]);  %Foot actuation for left front leg
datain(:,[9])=2*128-datain(:,[9]);  %Foot actuation for right rear leg

%Build a new table of servo data
for i=1:numLegs
    dataout(:,WingServ(i))=datain(:,(i-1)*3+1);
    dataout(:,StrokeServ(i))=datain(:,(i-1)*3+2);
    dataout(:,FootServ(i))=datain(:,(i-1)*3+3);
end
%Add the step durations
dataout(:,13)=datain(:,13);



